/*****************************************************************************
 This file is part of the Changedfiles system. 
 $Id: changedfiles.h,v 1.9 2003/02/03 04:43:00 rocky Exp $

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or (at
 your option) any later version.

 This program is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 USA
******************************************************************************/
/*
 * General definitions and structs for the Changedfiles module.
 */

#ifndef _CHANGEDFILES_H
#define _CHANGEDFILES_H

#define SUSER_UID  0
#define SUSER_GID  0

#define SYS_chfcomm 181
#define SYS_chfread 182

#define SYS_UNUSED -1
#define DFLT_ARG -1

#ifdef DEBUG
#define dcmn_err(X) cmn_err X
#else
#define dcmn_err(X)
#endif

/*
 * Configuration structure
 */
enum feature { OFF = 0, ON };

typedef struct chf_config {
    enum feature debug;
} chf_config_t;

/*
 * Structure for the syscall redirection
 */
typedef struct chf_syscall {

    int64_t(*sc) ();		/* Original syscall address */
    int64_t(*nc) ();		/* New syscall address */

#ifdef _LP64
    unsigned short flags;	/* Flags */
#else
    unsigned char flags;
#endif
    int index;			/* Syscall index */
    char narg;			/* Number of arguments, -1 = keep default */
    char onarg;			/* Original value */
} chf_syscall_t;

/*
 * Possible request values. 
 */
enum request { GET, SET, SIZE, OVERFLOW };

/*
 * Intercepted syscalls
 */
typedef enum chf_syscall_op { 
  OPEN=0,  OPEN64, RMDIR, MKDIR,  SYMLINK, LINK, UNLINK, CREAT, 
  CREAT64, CLOSE,  RENAME, CHMOD, PUTMSG, CHFCOMM
} chf_syscall_op;

#endif				/* _CHANGEDFILES_H */
